package bitel.billing.test.convert;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bitel.billing.common.CommonTimeUtils;
import bitel.billing.common.CommonUtils;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.DefaultServerSetup;
import bitel.billing.server.util.TimeUtils;

public class Tomkevi4
{
    private static DefaultServerSetup bgSetup = null;

    /*
    private static final String CONTRACT_TABLE_FILE_1 = "_001.txt"; //TODO
    private static final String STREET_TABLE_FILE_1 = "_001_street.txt";
    
    private static final String CONTRACT_TABLE_FILE_2 = "_002.txt"; //TODO
    private static final String STREET_TABLE_FILE_2 = "_002_street.txt";
    */
    private static Map<String,String> CONTRACT_TABLE_FILES = new HashMap<String,String>();
    private static Map<String,String> STREET_TABLE_FILES = new HashMap<String,String>();
    static{
        CONTRACT_TABLE_FILES.put( "001", "_001_50.txt" );
        CONTRACT_TABLE_FILES.put( "002", "_002_50.txt" );
        //CONTRACT_TABLE_FILES.put( "001", "_001.txt" );
        //CONTRACT_TABLE_FILES.put( "002", "_002.txt" );
        STREET_TABLE_FILES.put( "001", "_001_street.txt" );
        STREET_TABLE_FILES.put( "002", "_002_street.txt" );
    }

    private static final Date currDate = new Date();

    private static String rootDbfDir = null;
    
    private static String CONTRACT_NAME_PREFIX = "CTV";

    // -----------------------   ------------------------------
    // 8  : 0x7F80000000000000L = 9187343239835811840
    private static final long GROUP_BITMASK_TOTAL = 0x4000000000000000L;
    private static Map<String,Long> GROUP_BITMASK_DB = new HashMap<String,Long>();
    private static Map<String,Long> GROUP_BITMASK_TARIFF = new HashMap<String,Long>(){};
    static{
        GROUP_BITMASK_DB.put( "001", 0x2000000000000000L );
        GROUP_BITMASK_DB.put( "002", 0x1000000000000000L );
        GROUP_BITMASK_TARIFF.put( "1", 0x0800000000000000L );
        GROUP_BITMASK_TARIFF.put( "2", 0x0400000000000000L );
        GROUP_BITMASK_TARIFF.put( "3", 0x0200000000000000L );
        GROUP_BITMASK_TARIFF.put( "4", 0x0100000000000000L );
        GROUP_BITMASK_TARIFF.put( "5", 0x0080000000000000L );
    }

    private static final int PATTERN_ID = 16; 
    
    //  - 
    private static final int CITY_ID = 25;
    private static final String CITY_NAME = "";
    
    private static final int FIO_PID = 1;
    private static final int PHONE_PID = 6;
    private static final int ADDRESS_PID = 19;
    private static final int ADDRESS_RAW_PID = 10;
    private static final int DATE_PID = 27;
    
    private static final String DB_url = "jdbc:mysql://192.168.184.245/bgbilling_test?useUnicode=true&characterEncoding=Cp1251&allowUrlInLocalInfile=true&zeroDateTimeBehavior=convertToNull&jdbcCompliantTruncation=false";
    private static final String DB_user = "root";
    private static final String DB_pswd = "";

/*
    // -----------------------  ------------------------------
    private static final long GROUP_BITMASK_TOTAL = 0x4000000000000000L;
    private static Map<String,Long> GROUP_BITMASK_DB = new HashMap<String,Long>();
    private static Map<String,Long> GROUP_BITMASK_TARIFF = new HashMap<String,Long>(){};
    static{
        GROUP_BITMASK_DB.put( "001", 0x2000000000000000L );
        GROUP_BITMASK_DB.put( "002", 0x1000000000000000L );
        GROUP_BITMASK_TARIFF.put( "1", 0x0800000000000000L );
        GROUP_BITMASK_TARIFF.put( "2", 0x0400000000000000L );
        GROUP_BITMASK_TARIFF.put( "3", 0x0200000000000000L );
        GROUP_BITMASK_TARIFF.put( "4", 0x0100000000000000L );
        GROUP_BITMASK_TARIFF.put( "5", 0x0080000000000000L );
    }
    
    private static final int PATTERN_ID = 9;
    
    //  - 
    private static final int CITY_ID = 1;
    private static final String CITY_NAME = "-";
    
    private static final int FIO_PID = 1;
    private static final int PHONE_PID = 5;
    private static final int ADDRESS_PID = 3;
    private static final int ADDRESS_RAW_PID = 0;
    private static final int DATE_PID = 13;
    
    private static final String DB_url = "jdbc:mysql://127.0.0.1/bgbilling?useUnicode=true&characterEncoding=Cp1251&allowUrlInLocalInfile=true&zeroDateTimeBehavior=convertToNull&dbcCompliantTruncation=false";
    private static final String DB_user = "bill";
    private static final String DB_pswd = "bgbilling";
*/    
    public static void main( String[] args )
    {
        Connection con = null;
        rootDbfDir = args[0];
        try
        {
            bgSetup = new DefaultServerSetup();
            bgSetup.setValue( "db.driver", "com.mysql.jdbc.Driver" );                                           
            bgSetup.setValue( "db.url", DB_url );
            bgSetup.setValue( "db.user", DB_user );
            bgSetup.setValue( "db.pswd", DB_pswd );
            bgSetup.initConnectionPool();
            //con = bgSetup.getDBConnectionFromPool();
            con = bgSetup.getDBConnection();
            //
            ContractManager manager =  new ContractManager( con );
            Map<String, Integer> billingTarifMap = ConvertUtil.getBillingTariffMap( bgSetup );            
            Map<Integer, Map<String, Integer> > billingHouseMap = ConvertUtil.getBillingHouseMap( bgSetup );
            Map<String, Integer> billingStreetMap = ConvertUtil.getBillingStreetMap( bgSetup );
            //
            System.out.println("deleting contracts...");
            EventProcessor.initProcessor( bgSetup, false );
            //   
            long GROUP_BITMASK_ALL = GROUP_BITMASK_TOTAL;
            for( long mask : GROUP_BITMASK_DB.values() )
            {
                GROUP_BITMASK_ALL |= mask;
            }
            for( long mask : GROUP_BITMASK_TARIFF.values() )
            {
                GROUP_BITMASK_ALL |= mask;
            }
            ConvertUtil.removeContracts( GROUP_BITMASK_ALL, bgSetup );
            //if(true)return;
            //
            //    
            int contractCount = 0;
            for( Entry<String,String> dbFile : CONTRACT_TABLE_FILES.entrySet() )
            {
                String dbName = dbFile.getKey();
                String dbContractFile = dbFile.getValue();
                String dbStreetFile = STREET_TABLE_FILES.get( dbName );
                //
                String filePath = rootDbfDir + "/" + dbContractFile;
                System.out.println("load users... processing " + filePath + " ...");
                List<Map<String,String>> usersDbf = ConvertUtil.loadTxtDB( filePath, "cp1251", "\\|",
                                                             "N_LG",
                                                             "DAT_ON",
                                                             "C_IN",
                                                             "C_COD",
                                                             "PAC",
                                                             "C_NAME",
                                                             "ID_DILER",
                                                             "ID_CITY",
                                                             "ID_STREET",
                                                             "HOM",
                                                             "KVAR",
                                                             "PHONE",
                                                             "KOL_ON",
                                                             "DAT_ACT",
                                                             "C_ID",
                                                             "RN",
                                                             "RD",
                                                             "DAT_ISK",
                                                             "DAT_OPL",
                                                             "DOK",
                                                             "SUM_IN",
                                                             "K_OST",
                                                             "ID_TV",
                                                             "ID_CAB" 
                                                             //  -    
                                                             ); 
                System.out.println( usersDbf.size() + " users was found");
                //
                filePath = rootDbfDir + "/" + dbStreetFile;
                System.out.println("load streets... processing " + filePath + " ...");
                List<Map<String,String>> streetsDbf = ConvertUtil.loadTxtDB( filePath, "cp1251", "\\|",
                                                             "STREET",
                                                             "ID_STREET" );
                System.out.println( streetsDbf.size() + " streets in dbf was found");
                Map<String, Integer> preparedStreetMap = getPreparedStreets( con, billingStreetMap, streetsDbf );
                Map<Integer, String> billingStreetMapIdTitle = reverseKeyValue( billingStreetMap );
                //
                for ( Map<String, String> map : usersDbf )
                {
                    //   
                    //String number = map.get( "C_COD" );
                    String number = CONTRACT_NAME_PREFIX + ConvertUtil.addNull( contractCount+1, 8 );
                    //
                    Date startDate = CommonTimeUtils.parseDate( map.get( "C_IN" ), "dd.MM.yyyy" );
                    Contract contract = manager.createFromPattern( PATTERN_ID, number, CommonTimeUtils.convertDateToCalendar( startDate ), "" );
                    if (contract != null)
                    {
                        int cid = contract.getID();
                        //  : ,  
                        updateContactInfo( cid, map, con );
                        //     
                        ConvertUtil.addContactGroup( cid, GROUP_BITMASK_DB.get( dbName ), con );
                        //  
                        updateContactBalance( cid, map, currDate, con );
                        //  
                        updateTarifs( cid, map, billingTarifMap, con );
                        //     
                        ConvertUtil.addContactGroup( cid, GROUP_BITMASK_TARIFF.get( map.get( "PAC" ).trim() ), con );
                        ConvertUtil.addContactParamString( cid, con, map.get( "C_NAME" ), FIO_PID );
                        ConvertUtil.addContactParamString( cid, con, map.get( "PHONE" ), PHONE_PID );
                        ConvertUtil.addContactParamDate( cid, con, startDate, DATE_PID );                    
                        updateAddress(cid, map, preparedStreetMap, billingHouseMap, billingStreetMapIdTitle, con ); 
                        ++contractCount;
                    }
                    //  
                    System.out.println(contractCount);
                    //
                    if ( contractCount > 0  && contractCount % 1000 == 0 )
                    {
                        //System.out.println(contractCount);
                        //
                        ConvertUtil.closeConnection( con );
                        con= bgSetup.getDBConnection();
                        manager =  new ContractManager( con );
                        //
                        System.gc();
                        System.gc();
                        System.gc();
                        System.gc();
                    }
                }           
                System.out.println( "\n" + contractCount + " contracts was added");
            }            
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            ConvertUtil.closeConnection( con );
            System.out.println("the end, total time = " + ( System.currentTimeMillis() - currDate.getTime() )/1000 + " sec" );
        }
    }

    /**
     *  1 DBF (_dbf/_dbf)  2   
     * (_dbf => _)    -  .
     *       -  
     *    .
     * 
     * @param con
     * @param billingStreetMap
     *               (_=>_)
     * @param streetsDbf
     *              dbf
     */
    private static Map<String, Integer> getPreparedStreets( Connection con, Map<String, Integer> billingStreetMap, List<Map<String, String>> streetsDbf ) throws UnsupportedEncodingException, IOException, SQLException
    {
        Map<String, Integer> preparedStreetMap = new HashMap<String, Integer>();
        //
        for( Map<String,String> recordDbf : streetsDbf )
        {
            String id_dbf = recordDbf.get( "ID_STREET" );
            String title_dbf = recordDbf.get( "STREET" );
            Integer billing_id = billingStreetMap.get( title_dbf );
            if(billing_id==null)
            {
                System.out.print("street '"+title_dbf+"' not found in billing, added...");
                String query = "INSERT into address_street(title) VALUES(?) ";
                PreparedStatement ps =  con.prepareStatement(   query );
                ps.setString( 1, title_dbf );      
                ps.executeUpdate();
                ps.close();
                billing_id = ConvertUtil.lastInsertId( con );
                System.out.println("ok. id="+billing_id);
                //
                billingStreetMap.put( title_dbf, billing_id );
            }
            preparedStreetMap.put( id_dbf, billing_id );
        }
        return preparedStreetMap;
    }
    
    /**
     *     "".
     * @param cid
     * @param map
     * @param con
     * @throws SQLException
     */
    private static void updateContactInfo( int cid, Map<String, String> map, Connection con ) throws SQLException
    {
        String fio = map.get( "C_NAME" );
        String query = "UPDATE contract SET gr=gr|?, comment=? WHERE id=?";
        PreparedStatement ps = con.prepareStatement( query );
        int idx = 1;
        ps.setLong( idx++, GROUP_BITMASK_TOTAL );
        ps.setString( idx++, fio );
        ps.setInt( idx++, cid );
        ps.executeUpdate();
        ps.close();
    }
    
    private static void updateContactBalance( int cid,
                                              Map<String, String> map,
                                              Date currDate,
                                              Connection con ) throws SQLException
    {
        Calendar cal = new GregorianCalendar();
        cal.setTime( currDate );
        int year = cal.get( Calendar.YEAR );
        int month = cal.get( Calendar.MONTH ) + 1;
        String balance = map.get( "K_OST" );
        if ( !CommonUtils.isEmptyString( balance ) )
        {
            String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
            PreparedStatement ps = con.prepareStatement( query );
            int idx = 1;
            ps.setInt( idx++, year );
            ps.setInt( idx++, month );
            ps.setInt( idx++, cid );
            ps.setDouble( idx++, Double.valueOf( balance ) );
            ps.executeUpdate();
            ps.close();
        }
    }
    
    private static void updateTarifs( int cid, Map<String, String> map, Map<String, Integer> billingTarifMap, Connection con ) throws SQLException
    {
        String tarifName = map.get( "PAC" ).trim();
        if ( !CommonUtils.isEmptyString( tarifName ) )
        {            
            Integer tpid = billingTarifMap.get( tarifName );
            if ( tpid != null )
            {
                String query = "INSERT INTO contract_tariff( cid, tpid) VALUES ( ?, ?)";
                PreparedStatement ps = con.prepareStatement( query );
                ps.setInt( 1, cid );
                ps.setInt( 2, tpid );
                ps.executeUpdate();
                ps.close();
            }
            else
            {
                tpid = ConvertUtil.addNewTariff( con, tarifName );
                System.out.println( "new Tariff was added: " + tarifName );
                billingTarifMap.put( tarifName, tpid );
            }
        }
    }
    
    private static void updateAddress( int cid,
                                       Map<String, String> map,
                                       Map<String, Integer> billingStreetMap,
                                       Map<Integer, Map<String, Integer>> billingHouseMap,
                                       Map<Integer, String> billingStreetMapIdTitle,
                                       Connection con ) throws SQLException
    {
        //String cityId = map.get( "ID_CITY" );        
        Integer streetId = billingStreetMap.get( map.get( "ID_STREET" ) );
        if (streetId==null)
        {
            System.out.println( "ERROR: not street id, ID_STREET="+map.get( "ID_STREET" )  );
            return;
        }
        String houseNumFrac = map.get( "HOM" );
        String flatNum = map.get( "KVAR" );
        //
        Integer houseNum = null;
        String houseFrac = null;
        int posSlash = houseNumFrac.indexOf( "/" );
        if( posSlash!=-1 )
        {
            houseNum = ConvertUtil.parseInteger( houseNumFrac.substring( 0, posSlash ), 0 );
            houseFrac = houseNumFrac.substring( posSlash+1 );
        }
        else
        {
            posSlash = houseNumFrac.indexOf( "\\" );
            if( posSlash!=-1 )
            {
                houseNum = ConvertUtil.parseInteger( houseNumFrac.substring( 0, posSlash ), 0 );
                houseFrac = houseNumFrac.substring( posSlash+1 );
                //       -   
                //    '/'       
                //   -       .
                houseNumFrac = houseNum + "/" + houseFrac;
            }
            else
            {
                Pattern pattern1 = Pattern.compile( "^(\\d+)(\\D+)$" );
                Matcher m = null;
                if( (m = pattern1.matcher( houseNumFrac )).find() )
                {
                    houseNum = ConvertUtil.parseInteger( m.group( 1 ), 0 );
                    houseFrac = m.group( 2 ).toLowerCase();
                    houseNumFrac = houseNum + "/" + houseFrac;
                }
                else
                {                
                    houseNum = ConvertUtil.parseInteger( houseNumFrac, 0 );
                    houseFrac = "";
                }
            }
        }
        //
        if( houseNum==0 )
        {
            System.out.println( "ERROR: houseNum=0 for contract="+map.get( "C_COD" ) );
            return;
        }
        //
        String streetTitle = billingStreetMapIdTitle.get( streetId );
        if (streetTitle==null)
        {
            System.out.println( "ERROR: not street title, streetId="+streetId );
            return;
        }
        //
        Map<String, Integer> houses = billingHouseMap.get( streetId ); 
        if ( houses == null )
        {
            houses = new HashMap<String, Integer>();
            billingHouseMap.put( streetId, houses );
        }
        //
        Integer houseId =  houses.get( houseNumFrac );
        if ( houseId == null )
        {
            String query = "INSERT INTO address_house " + "( cityid,  areaid, quarterid, streetid,"
               + " house, frac, box_index, amount, comment, dt) " + "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
            PreparedStatement ps =  con.prepareStatement(   query );
            ps.setInt( 1, CITY_ID );
            ps.setInt( 2, 0 );
            ps.setInt( 3, 0 );
            ps.setInt( 4, streetId );
            ps.setInt( 5, houseNum );
            ps.setString( 6, houseFrac );
            ps.setString( 7, "" );
            ps.setInt( 8, 0 );
            ps.setString( 9, "" );
            ps.setDate( 10, TimeUtils.convertDateToSQL( currDate ) );
            ps.executeUpdate();
            ps.close();
            houseId = ConvertUtil.lastInsertId( con );
            houses.put( houseNumFrac, houseId );
            System.out.println( "new house was added: streetId=" + streetId + ", houseNum=" + houseNum + ", houseFrac='"+ houseFrac + "'" );
        }
        //
        String addressFormat = "(${index})(, ${city})(, ${area})(, ${quarter})(, . ${street})(, . ${house})(, . ${frac})(, . ${flat})( ${room})(, ${pod} .)(, ${floor} .)";
        String addressFull = ConvertUtil.getAddress( "", CITY_NAME, "", "", streetTitle, String.valueOf( houseNum ), houseFrac, flatNum, "", "", "", "", addressFormat );
        //
        String query = "INSERT INTO contract_parameter_type_2 " +
        "( cid, pid, hid, flat,  pod, floor, address, comment, room) " +
        "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ? )";
        PreparedStatement ps =  con.prepareStatement( query );
        ps.setInt( 1, cid );
        ps.setInt( 2, ADDRESS_PID );
        ps.setInt( 3, houseId );
        ps.setString( 4, flatNum );
        ps.setInt( 5, -1 );
        ps.setInt( 6, -1 );
        ps.setString( 7, addressFull );
        ps.setString( 8, "" );
        ps.setString( 9, "" );
        ps.executeUpdate();
        ps.close();        
        //
        if (ADDRESS_RAW_PID>0)
        {
            ConvertUtil.addContactParamString( cid, con, addressFull, ADDRESS_RAW_PID );
        }
    }

    private static Map<Integer, String> reverseKeyValue( Map<String, Integer> map )
    {
        Map<Integer, String> reverseKeyValueMap = new HashMap<Integer, String>();
        for( Entry<String, Integer> e : map.entrySet() )
        {
            reverseKeyValueMap.put( e.getValue(), e.getKey() );
        }
        return reverseKeyValueMap;
    }
}
